package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import org.eclipse.draw2d.Border;
import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.Generic_GeneratorItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;
import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;

/**
 * @generated
 */
public class Generic_GeneratorEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2027;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public Generic_GeneratorEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new Generic_GeneratorItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		Generic_GeneratorFigure figure = new Generic_GeneratorFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public Generic_GeneratorFigure getPrimaryShape() {
		return (Generic_GeneratorFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Generic_GeneratorNameEditPart) {
			((Generic_GeneratorNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureGeneric_GeneratornameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode().DPtoLP(40), getMapMode().DPtoLP(40));
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model so
	 * you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane. Respects
	 * layout one may have set for generated figure.
	 * 
	 * @param nodeShape
	 *            instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(Generic_GeneratorNameEditPart.VISUAL_ID));
	}

	@Override
	protected void refreshVisuals() {
		super.refreshVisuals();

		View view = (View) getModel();
		EObject element = view.getElement();
		if (element instanceof Generic_Generator) {
			Generic_Generator generic_gen = (Generic_Generator) element;
			getPrimaryShape().getGeneric_GeneratorName().setText(generic_gen.getGeneratorType());
			GeneratorDescriptor descriptor = Generatorservice.getDefault().getGenerator(generic_gen.getId());
			if (descriptor != null) {
				getPrimaryShape().generic_GeneratorName.setIcon(descriptor.getSmallImage());
				if (descriptor.getGeneratorColor() != null)
					getPrimaryShape()//.getFigureGeneric_GeneratornameFigure()
							.setForegroundColor(descriptor.getGeneratorColor());
			}
		}
	}

	/**
	 * @generated not
	 */
	public class Generic_GeneratorFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureGeneric_GeneratornameFigure;
		private WrappingLabel generic_GeneratorName;
		private Figure container;

		/**
		 * @generated not
		 */
		public Generic_GeneratorFigure() {

			BorderLayout layoutThis = new BorderLayout();
			layoutThis.setHorizontalSpacing(3);
			this.setLayoutManager(layoutThis);
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(30), getMapMode().DPtoLP(30)));

			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(120), getMapMode().DPtoLP(30)));

			Border newBorder = new MarginBorder(5);
			this.setBorder(newBorder);
			createContents();

			// createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {
			container = new Figure();
			ToolbarLayout layout = new ToolbarLayout();
			layout.setStretchMinorAxis(true);
			layout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);

			container.setLayoutManager(layout);
			this.add(container, BorderLayout.CENTER);

			generic_GeneratorName = new WrappingLabel();
			generic_GeneratorName.setText("Generic_Generator");
			generic_GeneratorName.setAlignment(PositionConstants.CENTER);// TODO
			// :
			// this
			// one
			// need
			// to
			// be
			// different
			// in
			// many
			// kinds
			container.add(generic_GeneratorName);

			fFigureGeneric_GeneratornameFigure = new WrappingLabel();
			fFigureGeneric_GeneratornameFigure.setText("[null]");
			fFigureGeneric_GeneratornameFigure.setAlignment(PositionConstants.CENTER);
			container.add(fFigureGeneric_GeneratornameFigure);

		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureGeneric_GeneratornameFigure() {
			return fFigureGeneric_GeneratornameFigure;
		}

		public WrappingLabel getGeneric_GeneratorName() {
			return generic_GeneratorName;
		}

	}

}
