package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.ModelItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class ModelEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2015;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ModelEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new ModelItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		ModelFigure figure = new ModelFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public ModelFigure getPrimaryShape() {
		return (ModelFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ModelUriEditPart) {
			((ModelUriEditPart) childEditPart).setLabel(getPrimaryShape().getFigureModeluriFigure());
			return true;
		}
		if (childEditPart instanceof ModelNameEditPart) {
			((ModelNameEditPart) childEditPart).setLabel(getPrimaryShape().getFigureModelnameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode().DPtoLP(40), getMapMode().DPtoLP(40));
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(ModelUriEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class ModelFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureModeluriFigure;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureModelnameFigure;

		/**
		 * @generated
		 */
		public ModelFigure() {

			ToolbarLayout layoutThis = new ToolbarLayout();

			layoutThis.setStretchMinorAxis(true);

			layoutThis.setMinorAlignment(0);

			this.setLayoutManager(layoutThis);

			this.setForegroundColor(THIS_FORE);
			this.setMaximumSize(new Dimension(getMapMode().DPtoLP(250), getMapMode().DPtoLP(100)));
			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(50)));

			this.setBorder(new MarginBorder(getMapMode().DPtoLP(5), getMapMode().DPtoLP(5), getMapMode().DPtoLP(5),
					getMapMode().DPtoLP(5)));
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			WrappingLabel model0 = new WrappingLabel("Model", CallchainElementTypes.getImage(((View) getModel())
					.getElement().eClass()));
			model0.setForegroundColor(MODEL0_FORE);
			model0.setAlignment(PositionConstants.CENTER);
			this.add(model0);

			fFigureModelnameFigure = new WrappingLabel();
			fFigureModelnameFigure.setText("[null]");
			fFigureModelnameFigure.setForegroundColor(FFIGUREMODELNAMEFIGURE_FORE);
			fFigureModelnameFigure.setAlignment(PositionConstants.CENTER);
			//			fFigureModelnameFigure.setMaximumSize(new Dimension(getMapMode()
			//					.DPtoLP(100), getMapMode().DPtoLP(0)));

			this.add(fFigureModelnameFigure);

			fFigureModeluriFigure = new WrappingLabel();
			fFigureModeluriFigure.setText("[null]");
			fFigureModeluriFigure.setForegroundColor(FFIGUREMODELURIFIGURE_FORE);
			fFigureModeluriFigure.setAlignment(PositionConstants.CENTER);
			//			fFigureModeluriFigure.setMaximumSize(new Dimension(getMapMode()
			//					.DPtoLP(100), getMapMode().DPtoLP(0)));

			this.add(fFigureModeluriFigure);

		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureModeluriFigure() {
			return fFigureModeluriFigure;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureModelnameFigure() {
			return fFigureModelnameFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 0, 64, 128);

	/**
	 * @generated
	 */
	static final Color MODEL0_FORE = new Color(null, 0, 64, 128);

	/**
	 * @generated
	 */
	static final Color FFIGUREMODELURIFIGURE_FORE = new Color(null, 0, 64, 128);

	/**
	 * @generated
	 */
	static final Color FFIGUREMODELNAMEFIGURE_FORE = new Color(null, 0, 64, 128);

}
