package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallResCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallResReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallableNextCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallableNextReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallItemSemanticEditPolicy extends CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyShortcutsCommand(cc);
		View view = (View) getHost().getModel();
		if (view.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
			req.setElementToDestroy(view);
		}
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return getGEFWrapper(new ModelAliasCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return getGEFWrapper(new CallInCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return getGEFWrapper(new CallOutCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallRes_4022 == req.getElementType()) {
			return getGEFWrapper(new CallResCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return getGEFWrapper(new CallLibarysCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return getGEFWrapper(new CallArtifactCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallableNext_4028 == req.getElementType()) {
			return getGEFWrapper(new CallableNextCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallRes_4022 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return getGEFWrapper(new CommentDocumentedElementCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallableNext_4028 == req.getElementType()) {
			return getGEFWrapper(new CallableNextCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ModelAliasEditPart.VISUAL_ID:
			return getGEFWrapper(new ModelAliasReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case CallInEditPart.VISUAL_ID:
			return getGEFWrapper(new CallInReorientCommand(req));
		case CallOutEditPart.VISUAL_ID:
			return getGEFWrapper(new CallOutReorientCommand(req));
		case CallResEditPart.VISUAL_ID:
			return getGEFWrapper(new CallResReorientCommand(req));
		case CallLibarysEditPart.VISUAL_ID:
			return getGEFWrapper(new CallLibarysReorientCommand(req));
		case CallArtifactEditPart.VISUAL_ID:
			return getGEFWrapper(new CallArtifactReorientCommand(req));
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getGEFWrapper(new CommentDocumentedElementReorientCommand(req));
		case CallableNextEditPart.VISUAL_ID:
			return getGEFWrapper(new CallableNextReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
