package de.urszeidler.eclipse.callchain.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResSuperimposeEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainDiagramEditorPlugin;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainParserProvider;

/**
 * @generated
 */
public class CallchainNavigatorLabelProvider extends LabelProvider implements ICommonLabelProvider,
		ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		CallchainDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		CallchainDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof CallchainNavigatorItem && !isOwnView(((CallchainNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof CallchainNavigatorGroup) {
			CallchainNavigatorGroup group = (CallchainNavigatorGroup) element;
			return CallchainDiagramEditorPlugin.getInstance().getBundledImage(group.getIcon());
		}

		if (element instanceof CallchainNavigatorItem) {
			CallchainNavigatorItem navigatorItem = (CallchainNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://urszeidler.de/callchain/2008/flowmodel?Calls", CallchainElementTypes.Calls_1000); //$NON-NLS-1$
		case ModelEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?Model", CallchainElementTypes.Model_2015); //$NON-NLS-1$
		case AtlResEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?AtlRes", CallchainElementTypes.AtlRes_2016); //$NON-NLS-1$
		case CallEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?Call", CallchainElementTypes.Call_2017); //$NON-NLS-1$
		case MMEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?MM", CallchainElementTypes.MM_2018); //$NON-NLS-1$
		case AtlLibaryEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?AtlLibary", CallchainElementTypes.AtlLibary_2019); //$NON-NLS-1$
		case ArtifactEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?Artifact", CallchainElementTypes.Artifact_2020); //$NON-NLS-1$
		case CommentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?Comment", CallchainElementTypes.Comment_2024); //$NON-NLS-1$
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://urszeidler.de/callchain/2008/flowmodel?Generic_Generator", CallchainElementTypes.Generic_Generator_2027); //$NON-NLS-1$
		case ModelAliasEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?ModelAlias", CallchainElementTypes.ModelAlias_4016); //$NON-NLS-1$
		case MMAliasEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?MMAlias", CallchainElementTypes.MMAlias_4017); //$NON-NLS-1$
		case ModelMmEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Model?mm", CallchainElementTypes.ModelMm_4018); //$NON-NLS-1$
		case AtlResSuperimposeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?AtlRes?superimpose", CallchainElementTypes.AtlResSuperimpose_4019); //$NON-NLS-1$
		case CallInEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Call?in", CallchainElementTypes.CallIn_4020); //$NON-NLS-1$
		case CallOutEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Call?out", CallchainElementTypes.CallOut_4021); //$NON-NLS-1$
		case CallResEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Call?res", CallchainElementTypes.CallRes_4022); //$NON-NLS-1$
		case CallLibarysEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Call?libarys", CallchainElementTypes.CallLibarys_4023); //$NON-NLS-1$
		case CallArtifactEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Call?artifact", CallchainElementTypes.CallArtifact_4024); //$NON-NLS-1$
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Comment?documentedElement", CallchainElementTypes.CommentDocumentedElement_4025); //$NON-NLS-1$
		case GeneratorUsesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Generator?uses", CallchainElementTypes.GeneratorUses_4026); //$NON-NLS-1$
		case GeneratorProduceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Generator?produce", CallchainElementTypes.GeneratorProduce_4027); //$NON-NLS-1$
		case CallableNextEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://urszeidler.de/callchain/2008/flowmodel?Callable?next", CallchainElementTypes.CallableNext_4028); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = CallchainDiagramEditorPlugin.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null && CallchainElementTypes.isKnownElementType(elementType)) {
			image = CallchainElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof CallchainNavigatorGroup) {
			CallchainNavigatorGroup group = (CallchainNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof CallchainNavigatorItem) {
			CallchainNavigatorItem navigatorItem = (CallchainNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getCalls_1000Text(view);
		case ModelEditPart.VISUAL_ID:
			return getModel_2015Text(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016Text(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017Text(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018Text(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019Text(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020Text(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024Text(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027Text(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016Text(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017Text(view);
		case ModelMmEditPart.VISUAL_ID:
			return getModelMm_4018Text(view);
		case AtlResSuperimposeEditPart.VISUAL_ID:
			return getAtlResSuperimpose_4019Text(view);
		case CallInEditPart.VISUAL_ID:
			return getCallIn_4020Text(view);
		case CallOutEditPart.VISUAL_ID:
			return getCallOut_4021Text(view);
		case CallResEditPart.VISUAL_ID:
			return getCallRes_4022Text(view);
		case CallLibarysEditPart.VISUAL_ID:
			return getCallLibarys_4023Text(view);
		case CallArtifactEditPart.VISUAL_ID:
			return getCallArtifact_4024Text(view);
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getCommentDocumentedElement_4025Text(view);
		case GeneratorUsesEditPart.VISUAL_ID:
			return getGeneratorUses_4026Text(view);
		case GeneratorProduceEditPart.VISUAL_ID:
			return getGeneratorProduce_4027Text(view);
		case CallableNextEditPart.VISUAL_ID:
			return getCallableNext_4028Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getCalls_1000Text(View view) {
		Calls domainModelElement = (Calls) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.isLogDefault());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getModel_2015Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.Model_2015, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(ModelUriEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5031); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getAtlRes_2016Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.AtlRes_2016, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(AtlResUriEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5033); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getCall_2017Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.Call_2017, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(CallNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5035); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getMM_2018Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.MM_2018, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(MMHandlerEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5036); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getAtlLibary_2019Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.AtlLibary_2019, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(AtlLibaryUriEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5039); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getArtifact_2020Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.Artifact_2020, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(ArtifactNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5041); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getComment_2024Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.Comment_2024, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(CommentDocEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5048); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getGeneric_Generator_2027Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.Generic_Generator_2027,
				(view.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
						.getType(Generic_GeneratorNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 5053); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getModelAlias_4016Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.ModelAlias_4016, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(ModelAliasAliasNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 6003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getMMAlias_4017Text(View view) {
		IAdaptable hintAdapter = new CallchainParserProvider.HintAdapter(CallchainElementTypes.MMAlias_4017, (view
				.getElement() != null ? view.getElement() : view), CallchainVisualIDRegistry
				.getType(MMAliasAliasNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			CallchainDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 6004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getModelMm_4018Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAtlResSuperimpose_4019Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallIn_4020Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallOut_4021Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallRes_4022Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallLibarys_4023Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallArtifact_4024Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCommentDocumentedElement_4025Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getGeneratorUses_4026Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getGeneratorProduce_4027Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCallableNext_4028Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return CallsEditPart.MODEL_ID.equals(CallchainVisualIDRegistry.getModelID(view));
	}

}
