/**
 * <copyright>
 * </copyright>
 *
 * $Id: GMF_GeneratorExe.java,v 1.4 2008/04/13 23:12:26 urs Exp $
 */
package de.urszeidler.eclipse.callchain.executors;

import java.io.IOException;
import java.text.MessageFormat;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.internal.bridge.transform.Messages;
import org.eclipse.gmf.internal.bridge.transform.TransformToGenModelOperation;
import org.eclipse.gmf.internal.bridge.transform.ValidationHelper;
import org.eclipse.gmf.internal.codegen.popup.actions.ExecuteTemplatesOperation;
import org.eclipse.gmf.mappings.Mapping;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.internal.progress.ProgressManager;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.GMFGeneratorKind;
import de.urszeidler.eclipse.callchain.GMF_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>EMF Generator</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link GMF_GeneratorExe#getKind <em>Kind</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class GMF_GeneratorExe implements ExecutorStep {
	private static final String GENMODELURI = "http://www.eclipse.org/gmf/2006/GenModel";
	private static final String MAPPINGMODELURI = "http://www.eclipse.org/gmf/2006/mappings";
	private static final String GENMODELURI2008 = "http://www.eclipse.org/gmf/2008/GenModel";
	private static final String MAPPINGMODELURI2008 = "http://www.eclipse.org/gmf/2008/mappings";
	private GMF_Generator generator;
	private Shell shell;

	public GMF_GeneratorExe(GMF_Generator generator) {
		super();
		this.generator = generator;
	}

	public GMF_GeneratorExe(GMF_Generator object, Shell shell) {
		super();
		this.generator = object;
		this.shell = shell;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public void generate(Object monitor) {
		IProgressMonitor pmonitor;
		if (monitor instanceof IProgressMonitor) {
			pmonitor = (IProgressMonitor) monitor;
			// pmonitor.beginTask(generator.getName(), 1);
//			if (shell == null)
//				if (Display.getCurrent() != null)
//					shell = Display.getCurrent().getActiveShell();

		}// end of if (monitor instanceof IProgressMonitor)
		else {

			pmonitor = new NullProgressMonitor();
		}

		try {

			switch (generator.getKind().getValue()) {
			// case TCGeneratorKind.OUTLINE_GENERATOR:
			// generateOutline(pmonitor);
			// break;
			case GMFGeneratorKind.DIAGRAM_GENERATOR_VALUE:
				createGMFDiagram(pmonitor);
				break;
			case GMFGeneratorKind.GEN_MODEL_VALUE:
				createGMFGenModel(pmonitor);
				break;
			// case GMFGeneratorKind.GRAPH_MODEL_VALUE:
			// createGMFGenModel(pmonitor);
			// break;

			default:
				break;
			}

		} finally {
			//pmonitor.done();
		}// end of try catch

	}

	private void createGMFGenModel(IProgressMonitor pmonitor) {
		final ResourceSetImpl resourceSet = new ResourceSetImpl();
		resourceSet.getURIConverter().getURIMap().putAll(
				EcorePlugin.computePlatformURIMap());
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();
		String strUri = getMappinModelURI(generator.getUses());
		Path file = new Path(strUri);
		IFile currentFile = wksroot.getFile(new Path(strUri));
		// Get the URI of the model file.
		URI mappingURI = URI.createPlatformResourceURI(currentFile
				.getFullPath().toString());

		// Create a resource for this file.
		// Resource emfResource = resourceSet.createResource(mappingURI);

		TransformToGenModelOperation op = new TransformToGenModelOperation(
				resourceSet);

		strUri = getGenModelURI(generator.getProduce());
		file = new Path(strUri);
		currentFile = wksroot.getFile(new Path(strUri));

		IFile target = currentFile;
		try {
			Mapping loadMappingModel = op
					.loadMappingModel(mappingURI, pmonitor);
			op.setGenURI(URI.createPlatformResourceURI(target.getFullPath()
					.toString(), true));
		} catch (CoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		IStatus s = op.executeTransformation(pmonitor);

		CallchainEditPlugin.log(s);
	}

	public Mapping loadMappingModel(ResourceSet rs, URI uri, IProgressMonitor pm)
			throws CoreException {
		Mapping content = null;
		IStatus status = Status.CANCEL_STATUS;
		Diagnostic validation = Diagnostic.CANCEL_INSTANCE;
		//IProgressMonitor monitor = null;
		try {
			// checkResourceSet(rs);
			if (uri == null) {
				throw new IllegalArgumentException(
						Messages.TransformToGenModelOperation_e_null_map_uri);
			}
			// monitor = (pm != null) ? new SubProgressMonitor(pm, 1,
			// SubProgressMonitor.PREPEND_MAIN_LABEL_TO_SUBTASK) : new
			// NullProgressMonitor();
			// String cancelMessage =
			// Messages.TransformToGenModelOperation_e_map_load_cancelled;
			//			monitor.beginTask("", 100); //$NON-NLS-1$
			// subTask(monitor, 0,
			// Messages.TransformToGenModelOperation_task_load, cancelMessage);
			// ModelLoadHelper loadHelper = new ModelLoadHelper(rs, uri);
			// if (!loadHelper.isOK()) {
			// throw new CoreException(loadHelper.getStatus());
			// }
			// subTask(monitor, 20,
			// Messages.TransformToGenModelOperation_task_validate,
			// cancelMessage);
			Resource resource = internalLoad(rs, uri);
			EObject root = resource.getContents().get(0);

			if (!(root instanceof Mapping)) {
				String msg = MessageFormat
						.format(
								Messages.TransformToGenModelOperation_e_wrong_root_element,
								root.getClass().getName());
				status = new Status(Status.ERROR, "plugin_id", msg);
				throw new CoreException(status);
			}
			content = (Mapping) root;
			validation = ValidationHelper.validate(content, true, pm);
//			monitor.worked(60);
			// if (Diagnostic.CANCEL == validation.getSeverity()) {
			// throw new CoreException(Plugin.createCancel(cancelMessage));
			// }
			return content;
		} catch (CoreException e) {
			throw e;
		} catch (Exception e) {
			IStatus error = new Status(Status.ERROR, "plugin_id",
					Messages.TransformToGenModelOperation_e_load_mapping_model,
					e);
			throw new CoreException(error);
		} finally {
			// setMapping(content, validation);
//			if (monitor != null) {
//				monitor.done();
//			}
		}
	}

	private static Resource internalLoad(ResourceSet resourceSet, URI uri) {
		Diagnostic diagnostic = Diagnostic.OK_INSTANCE;
		Resource resource = resourceSet.createResource(uri);
		assert resource != null;
		Exception rootException = null;
		try {
			resource.load(resourceSet.getLoadOptions());
		} catch (IOException e) {
			rootException = e instanceof Resource.IOWrappedException ? (Exception) e
					.getCause()
					: e;
			// include only non diagnostic exception in resource.getErrors()
			// if(!(e instanceof Resource.Diagnostic)) {
			//resource.getErrors().add(ModelLoadHelper.createDiagnostic(resource
			// , rootException));
			// }
		} catch (RuntimeException e) {
			EcorePlugin.INSTANCE.getPluginLogger().log(e);
			//resource.getErrors().add(ModelLoadHelper.createDiagnostic(resource
			// , e));
		}
		EList<Resource.Diagnostic> errors = resource.getErrors();
		EList<Resource.Diagnostic> warnings = resource.getWarnings();
		if (!errors.isEmpty() || !warnings.isEmpty()) {
			Diagnostic resourceDiagnostic = EcoreUtil.computeDiagnostic(
					resource, true);
			Integer severityOpt = new Integer(
					resourceDiagnostic.getSeverity() == Diagnostic.ERROR ? 0
							: 1);
			// String message =
			// MessageFormat.format(Messages.modelLoadedWithProblems,
			// new Object[] { severityOpt, resource.getURI() });

			Object[] data = (rootException != null) ? new Object[] {
					rootException, resource } : new Object[] { resource };
			// BasicDiagnostic loadDiagnostic = new
			// BasicDiagnostic(DIAGNOSTIC_SOURCE, resourceDiagnostic.getCode(),
			// message, data);
			// loadDiagnostic.addAll(resourceDiagnostic);
			// diagnostic = loadDiagnostic;
		}
		return resource;
	}

	private void createGMFlite(IProgressMonitor pmonitor) {
		// ExecuteLiteTemplatesOperation op = new
		// ExecuteLiteTemplatesOperation();
		// executeTemplateOperation(op);
	}

	private void createGMFDiagram(IProgressMonitor pmonitor) {
		ExecuteTemplatesOperation op = new ExecuteTemplatesOperation();
		executeTemplateOperation(op);
		// if (pmonitor != null)
		// pmonitor.worked(1);

		// ResourceSet srcResSet = new ResourceSetImpl();
		// ModelLoadHelper loadHelper = new ModelLoadHelper(srcResSet,
		// getGenModelURI());
		// Object root = loadHelper.getContentsRoot();
		// if (root instanceof GenDiagram) {
		// myGenModel = ((GenDiagram) root).getEditorGen();
		// } else if (root instanceof GenEditorGenerator) {
		// myGenModel = (GenEditorGenerator) root;
		// }
		// if (myGenModel != null && myGenModel.getDomainGenModel() != null) {
		// myGenModel.getDomainGenModel().reconcile();
		// }
		//
		//		
		// new Generator(getGenModel(),
		// CodeGenUIPlugin.getDefault().getEmitters(getGenModel()))

	}

	private void executeTemplateOperation(ExecuteTemplatesOperation op) {

//		try {
//			if (shell == null)
//				if (Display.getCurrent() != null)
//					shell = Display.getCurrent().getActiveShell();
//
//		} catch (Exception e) {
//			// TODO: handle exception
//		}
//		try {
//
//			if (shell == null)
//				if (Display.getDefault() != null)
//					shell = Display.getDefault().getActiveShell();
//
//		} catch (Exception e) {
//			// TODO: handle exception
//		}
//		try {
//			if (shell == null)
//				shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow()
//						.getShell();
//
//		} catch (Exception e) {
//			// TODO: handle exception
//		}
//		try {
//
//			
//	               
//            boolean disposeShell = (shell==null);
//            if (disposeShell) {
//                Display display = new Display();
//                shell = new Shell(display);
//            }
//
//				
//				
//				shell = PlatformUI.getWorkbench().getDisplay().getActiveShell();
//
//		} catch (Exception e) {
//			// TODO: handle exception
//		}
//		try {
//
//			if (shell == null)
//				shell = PlatformUI.getWorkbench().getDisplay().getShells()[0];
//
//		} catch (Exception e) {
//			// TODO: handle exception
//		}
		
		
		
		
		if (shell != null)
			op.setShell(shell);
		// if (pmonitor instanceof ProgressMonitorWrapper) {
		// ProgressMonitorWrapper pm = (ProgressMonitorWrapper) pmonitor;
		// op.setShell(pm.getWrappedProgressMonitor().)
		// }

		String strUri = getGenmodelUri();
		Path file = new Path(strUri);
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();

		IFile currentFile = wksroot.getFile(new Path(strUri));

		URI uri = URI.createPlatformResourceURI(currentFile.getFullPath()
				.toString());
		op.setGenModelURI(uri);
		try {
			op.run();
		} catch (Exception e) {
			EcorePlugin.INSTANCE.getPluginLogger().log(e);
		}
	}

	private String getGenmodelUri() {
		EList<Artifact> uses = generator.getUses();
		return getGenModelURI(uses);
	}

	private String getGenModelURI(EList<Artifact> uses) {
		for (Artifact artifact : uses) {
			if (artifact instanceof Model) {
				Model model = (Model) artifact;
				if (model.getMm() != null) {
					if (model.getMm().getUri().equals(GENMODELURI)
							|| model.getMm().getUri().equals(
									"uri:" + GENMODELURI)
							|| model.getMm().getUri().equals(GENMODELURI2008)
							|| model.getMm().getUri().equals(
									"uri:" + GENMODELURI2008))
						return model.getUri();

				}

			}
		}
		return null;
	}

	private String getMappinModelURI(EList<Artifact> uses) {
		for (Artifact artifact : uses) {
			if (artifact instanceof Model) {
				Model model = (Model) artifact;
				if (model.getMm() != null) {
					if (model.getMm().getUri().equals(MAPPINGMODELURI)
							|| model.getMm().getUri().equals(
									"uri:" + MAPPINGMODELURI)
							|| model.getMm().getUri().equals(
									MAPPINGMODELURI2008)
							|| model.getMm().getUri().equals(
									"uri:" + MAPPINGMODELURI2008))
						return model.getUri();

				}

			}
		}
		return null;
	}

	public void generate() {
		generate(null);
		// switch (generator.getKind().getValue()) {
		// // case TCGeneratorKind.OUTLINE_GENERATOR:
		// // generateOutline(pmonitor);
		// // break;
		// case GMFGeneratorKind.DIAGRAM_GENERATOR_VALUE:
		// createGMFDiagram(null);
		// break;
		// case GMFGeneratorKind.GEN_MODEL_VALUE:
		// createGMFGenModel(null);
		// break;
		//
		// default:
		// break;
		// }
	}

	@Override
	public String getTaskName() {
		return generator.getName();
	}

	public void setShell(Shell shell) {
		this.shell = shell;
	}

} // EMF_GeneratorImpl