/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.lauching.ui;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.ui.AbstractLaunchConfigurationTab;
import org.eclipse.debug.ui.ILaunchConfigurationTab;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.ReflectiveItemProviderAdapterFactory;
import org.eclipse.emf.edit.provider.resource.ResourceItemProviderAdapterFactory;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.viewers.CheckStateChangedEvent;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.dialogs.ElementTreeSelectionDialog;
import org.eclipse.ui.model.BaseWorkbenchContentProvider;
import org.eclipse.ui.model.WorkbenchLabelProvider;

import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.lauching.core.CallchainConfiguration;
import de.urszeidler.eclipse.callchain.lauching.core.CallchainLaunchConfigurationDelegate;
import de.urszeidler.eclipse.callchain.provider.CallchainItemProviderAdapterFactory;
import de.urszeidler.eclipse.swt.SWTWidgetFactory;

/**
 * <p>
 * CallchainTab
 * </p>
 * Created : 03.06.2008
 * 
 * @author urs
 * @version $Revision$, $Id$
 */
public class CallchainTab extends AbstractLaunchConfigurationTab implements
        ILaunchConfigurationTab {
    private Text resourceUri;
//    private Text name;
    private Button btnWorkspaceBrowse;
    private Button btnFileBrowse;
    private Combo callableCombobox;
    private ModifyListener modifyListener;
    private Button checkBox_chaincall;
    // private org.eclipse.swt.widgets.List skippList;
    protected Calls calls;
    // private ListViewer skippList1;
    private CheckboxTableViewer viewer;
    private List<Callable> skipList_list;
    private List<String> callablesToSkipp = new ArrayList<String>();
    private AdapterFactoryLabelProvider itemProvider;
	private Button checkBox_clearConsole;

    public void createControl(Composite parent) {
        Composite comp = new Composite(parent, SWT.NONE);
        setControl(comp);
        comp.setLayout(new GridLayout(1, true));
        comp.setLayoutData(new GridData(1, 1, true, true));
        comp.setFont(parent.getFont());

        this.modifyListener = new ModifyListener() {
            public void widgetSelected(SelectionEvent e) {
                Object source = e.getSource();

                updateLaunchConfigurationDialog();

            }

            public void modifyText(ModifyEvent e) {
                Object source = e.getSource();

                updateLaunchConfigurationDialog();

            }
        };

        createBasicConfigGui(comp);
        createScipCallableConfigGui(comp);
    }

    private void createScipCallableConfigGui(Composite parent) {
        Group group = SWTWidgetFactory.createGroup(parent, "skip callable", 5,
                8, GridData.FILL_BOTH);
        Composite comp = SWTWidgetFactory.createComposite(group, 5, 8,
                GridData.FILL_BOTH);
        GridLayout ld = (GridLayout) comp.getLayout();
        ld.marginWidth = 1;
        ld.marginHeight = 1;

        GridData gd = null;

        // CallchainAdapterFactory callchainAdapterFactory = new
        // CallchainAdapterFactory();

        // skippList = new org.eclipse.swt.widgets.List(parent, SWT.MULTI);
        viewer = CheckboxTableViewer.newCheckList(comp, SWT.MULTI);

        gd = new GridData(GridData.FILL_BOTH);
        gd.horizontalSpan = 5;
        gd.verticalSpan = 7;
        gd.verticalAlignment = SWT.FILL;
        gd.grabExcessHorizontalSpace = true;
        gd.grabExcessVerticalSpace = true;

        viewer.getTable().setLayoutData(gd);
        viewer.setContentProvider(new IStructuredContentProvider() {

            public void dispose() {
                // TODO Auto-generated method stub

            }

            public void inputChanged(Viewer viewer, Object oldInput,
                    Object newInput) {
                // TODO Auto-generated method stub

            }

            public Object[] getElements(Object inputElement) {
                if (inputElement instanceof List) {
                    List list = (List) inputElement;
                    return list.toArray();
                }// end of if (inputElement instanceof List)
                return null;
            }

        });
        
        itemProvider= new AdapterFactoryLabelProvider(
                getAdapterFactory());
        viewer.setLabelProvider(itemProvider);
        
        viewer.addCheckStateListener(new ICheckStateListener(){

            public void checkStateChanged(CheckStateChangedEvent event) {
                buildCallablesToSkipp();
                updateLaunchConfigurationDialog();
                
            }});

    }

    protected void buildCallablesToSkipp() {
        Object[] checkedElements = viewer.getCheckedElements();
        callablesToSkipp.clear();
        for (Object object : checkedElements) {
            callablesToSkipp.add(callableToName((Callable) object));
        }
        
    }

    private void createBasicConfigGui(Composite parent) {
        Group group = SWTWidgetFactory.createGroup(parent, "basic config", 5,
                2, GridData.FILL_HORIZONTAL);
        Composite comp = SWTWidgetFactory.createComposite(group, 5, 5,
                GridData.FILL_BOTH);
        GridLayout ld = (GridLayout) comp.getLayout();
        ld.marginWidth = 1;
        ld.marginHeight = 1;

        GridData gd = new GridData(SWT.BEGINNING, SWT.NORMAL, true, false);
        gd.horizontalSpan = 15;
        SWTWidgetFactory.createLabel(comp, "callchain model", 1);
        resourceUri = SWTWidgetFactory.createSingleText(comp, 2);
        resourceUri.setData(CallchainConfiguration.CALLCHAINURI);
        resourceUri.addModifyListener(modifyListener);

        btnWorkspaceBrowse = createPushButton(comp, "workspace", null); //$NON-NLS-1$
        btnWorkspaceBrowse.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                showWorkspaceDialog(resourceUri);
                Calls calls = CallchainLaunchConfigurationDelegate
                        .loadCallchain(resourceUri.getText());
                fillCallableCombobox(calls);
            }
        });

        btnFileBrowse = createPushButton(comp, "file", null);
        btnFileBrowse.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                showFileDialog(resourceUri);
                calls = CallchainLaunchConfigurationDelegate
                        .loadCallchain(resourceUri.getText());
                fillCallableCombobox(calls);

            }
        });

        SWTWidgetFactory.createLabel(comp, "transformation to start", 1);
        callableCombobox = new Combo(comp, SWT.DROP_DOWN);
        callableCombobox.setData(CallchainConfiguration.CALLABLENAME);
        callableCombobox.addModifyListener(new ModifyListener() {
            public void widgetSelected(SelectionEvent e) {
                Object source = e.getSource();
                fillSkipables(callableCombobox.getText());
                updateLaunchConfigurationDialog();

            }

            public void modifyText(ModifyEvent e) {
                Object source = e.getSource();
                fillSkipables(callableCombobox.getText());

                updateLaunchConfigurationDialog();

            }
        });
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.horizontalSpan = 4;
        callableCombobox.setLayoutData(gd);

        SWTWidgetFactory.createLabel(comp, "", 1);
        checkBox_chaincall = new Button(comp, SWT.CHECK);
        checkBox_chaincall.setText("execute in chain");
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.horizontalSpan = 4;
        checkBox_chaincall.setLayoutData(gd);
        checkBox_chaincall.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                viewer.getTable().setEnabled(checkBox_chaincall.getSelection());
                updateLaunchConfigurationDialog();
            }
        });

        SWTWidgetFactory.createLabel(comp, "", 1);
        checkBox_clearConsole = new Button(comp, SWT.CHECK);
        checkBox_clearConsole.setText("clear console");
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.horizontalSpan = 4;
        checkBox_clearConsole.setLayoutData(gd);
        checkBox_clearConsole.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                updateLaunchConfigurationDialog();
            }
        });

    }

    protected void fillSkipables(String text) {
        if (calls == null)
            return;

        Callable c = getCallable(text);
        if (c == null)
            return;

        skipList_list = new ArrayList<Callable>();
        while (c != null) {
            skipList_list.add(c);
            c = c.getNext();

        }
        viewer.setInput(skipList_list);
    }

    private String callableToName(Callable c) {
        if (c instanceof Call) {
            Call call = (Call) c;
            return call.getName();
        }// end of if (c instanceof Call)
        if (c instanceof Generator) {
            Generator generator = (Generator) c;
            return generator.getName();
        }// end of if (c instanceof Generator)
        return null;
    }

    private Callable getCallable(String text) {
        EList<Call> list = calls.getCall();
        for (Call call : list) {
            if (call.getName() != null) {
                if (text.endsWith(call.getName()))
                    return call;
            }
        }
        EList<Generator> generators = calls.getGenerators();
        for (Generator generator : generators) {
            if (generator.getName() != null) {
                if (text.endsWith(generator.getName()))
                    return generator;
            }
        }

        return null;
    }

    protected void fillCallableCombobox(Calls calls) {
        if (calls == null)
            return;

        List<String> itemlist = new ArrayList<String>();
        EList<Call> list = calls.getCall();
        for (Call call : list) {
            if (call.getName() != null) {
                if (calls.getDefaultStartPoint() == call)
                    itemlist.add("[default] " + call.getName());
                else if (calls.getStartPoints().contains(call))
                    itemlist.add("[startpoint] " + call.getName());
                else
                    itemlist.add(call.getName());
            }
        }
        EList<Generator> generators = calls.getGenerators();
        for (Generator generator : generators) {
            if (generator.getName() != null) {
                itemlist.add(generator.getName());
            }
        }

        String[] items = itemlist.toArray(new String[] {});
        callableCombobox.setItems(items);

    }

    public String getName() {
        return "start callchain";
    }

    /**
     * Subclasses must implement this method to return the
     * ComposedAdapterFactory
     * 
     * @return the ComposedAdapterFactory
     */
    public ComposedAdapterFactory getAdapterFactory() {
        List<AdapterFactory> factories = new ArrayList<AdapterFactory>();
        factories.add(new CallchainItemProviderAdapterFactory());
        factories.add(new ResourceItemProviderAdapterFactory());
        factories.add(new ReflectiveItemProviderAdapterFactory());

        return new ComposedAdapterFactory(factories);
    }

    public void initializeFrom(ILaunchConfiguration configuration) {
        try {
            if (configuration.getAttributes().containsKey(
                    CallchainConfiguration.CALLCHAINURI)) {
                resourceUri.setText((String) configuration.getAttributes().get(
                        CallchainConfiguration.CALLCHAINURI));
                calls = CallchainLaunchConfigurationDelegate
                        .loadCallchain(resourceUri.getText());
                fillCallableCombobox(calls);
            }
            if (configuration.getAttributes().containsKey(
                    CallchainConfiguration.CHAINCALLS)) {
                try {
                    checkBox_chaincall.setSelection(configuration.getAttribute(
                            CallchainConfiguration.CHAINCALLS, false));
                    viewer.getTable().setEnabled(checkBox_chaincall.getSelection());

                } catch (Exception e) {
                }
            }
            if (configuration.getAttributes().containsKey(
                    CallchainConfiguration.CLEARCONSOLE)) {
                try {
                    checkBox_clearConsole.setSelection(configuration.getAttribute(
                            CallchainConfiguration.CLEARCONSOLE, true));

                } catch (Exception e) {
                }
            }
            if (configuration.getAttributes().containsKey(
                    CallchainConfiguration.CALLABLENAME))
                callableCombobox.setText((String) configuration.getAttributes()
                        .get(CallchainConfiguration.CALLABLENAME));
            
            if(configuration.getAttributes().containsKey(CallchainConfiguration.SKIPPLIST)){
                List list = configuration.getAttribute(CallchainConfiguration.SKIPPLIST, new ArrayList<String>());
                for (Callable c : skipList_list) {
                    if(list.contains(callableToName(c))){
                        viewer.setChecked(c, true);
                        callablesToSkipp.add(callableToName(c));
                    }
                }
                
            }
            

        } catch (CoreException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void performApply(ILaunchConfigurationWorkingCopy configuration) {
        if (resourceUri.getText() != null)
            configuration.setAttribute(CallchainConfiguration.CALLCHAINURI,
                    resourceUri.getText());
        if (callableCombobox.getText() != null)
            configuration.setAttribute(CallchainConfiguration.CALLABLENAME,
                    callableCombobox.getText());

        configuration.setAttribute(CallchainConfiguration.CHAINCALLS,
                checkBox_chaincall.getSelection());
        configuration.setAttribute(CallchainConfiguration.CLEARCONSOLE,
                checkBox_clearConsole.getSelection());
        
        
        configuration.setAttribute(CallchainConfiguration.SKIPPLIST, callablesToSkipp);

    }

    public void setDefaults(ILaunchConfigurationWorkingCopy configuration) {
        // TODO Auto-generated method stub

    }

    private void showWorkspaceDialog(Text text) {
        ElementTreeSelectionDialog dialog = new ElementTreeSelectionDialog(
                getShell(), new WorkbenchLabelProvider(),
                new BaseWorkbenchContentProvider());
        dialog.setTitle("wsdialogtitel");
        dialog.setMessage("wsdialogmessage");
        dialog.setInput(ResourcesPlugin.getWorkspace().getRoot());

        if (dialog.open() == IDialogConstants.OK_ID) {
            IResource resource = (IResource) dialog.getFirstResult();
            String arg = resource.getFullPath().toOSString().toString();
            if (text != null)
                text.setText(arg);
        }
    }

    private void showFileDialog(Text txt) {
        String filePath = txt.getText();
        FileDialog dialog = new FileDialog(getShell(), SWT.SAVE);
        filePath = dialog.open();
        if (filePath != null) {
            txt.setText(filePath);
        }
    }

}
