package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import java.util.Arrays;
import java.util.List;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.RegisteredPackageDialog;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.ui.PlatformUI;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.tabbedpropery.basicsections.AbstractTextButtonSection;

/**
 * A section display a text field to edit/see String features
 *
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * @generated not
 */
public class MMUriSection extends AbstractTextButtonSection {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     * @generated
     */
    protected String getLabelText() {
        return "Uri:";
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     * @generated
     */
    protected EStructuralFeature getFeature() {
        return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }

    @Override
    protected void handleButtonPressed() {
        ExtendedLoadResourceDialog loadResourceDialog = new ExtendedLoadResourceDialog(
                PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
                (EditingDomain) null) {

            protected void prepareBrowseRegisteredPackagesButton(
                    Button browseRegisteredPackagesButton) {
                uriText = getText().getText();
                browseRegisteredPackagesButton
                        .addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent event) {
                                RegisteredPackageDialog registeredPackageDialog = new RegisteredPackageDialog(
                                        getShell());
                                registeredPackageDialog.open();
                                Object[] result = registeredPackageDialog
                                        .getResult();
                                if (result != null) {
                                    List nsURIs = Arrays.asList(result);
                                    for (Object uri : nsURIs) {

                                        //ResourceSet resourceSet = new ResourceSetImpl();
                                        //resourceSet.getURIConverter().getURIMap().putAll(EcorePlugin.computePlatformURIMap());
                                        StringBuffer uris = new StringBuffer();
                                        //Map ePackageNsURItoGenModelLocationMap = EcorePlugin.getEPackageNsURIToGenModelLocationMap();
                                        //                       for (int i = 0, length = result.length; i < length; i++)
                                        //                       {
                                        //                         URI location = (URI)ePackageNsURItoGenModelLocationMap.get(result[i]);
                                        //                         Resource resource = resourceSet.getResource(location, true);
                                        //                         EcoreUtil.resolveAll(resource);
                                        //                       }
                                        //                       for (Iterator i = resourceSet.getResources().iterator(); i.hasNext(); )
                                        //                       {
                                        //                         Resource resource = (Resource)i.next();
                                        //                         for (TreeIterator j = 
                                        //                                new EcoreUtil.ContentTreeIterator(resource.getContents())
                                        //                                {
                                        //                                  protected Iterator getEObjectChildren(EObject eObject)
                                        //                                  {
                                        //                                    return 
                                        //                                      eObject instanceof EPackage ? 
                                        //                                        ((EPackage)eObject).getESubpackages().iterator() : 
                                        //                                          Collections.EMPTY_LIST.iterator();
                                        //                                  }
                                        //                                };
                                        //                              j.hasNext(); )
                                        //                         {
                                        //                           Object content = j.next();
                                        //                           if (content instanceof EPackage)
                                        //                           {
                                        //                             EPackage ePackage = (EPackage)content;
                                        //                             if (nsURIs.contains(ePackage.getNsURI()))
                                        //                             {
                                        //                               uris.append(resource.getURI());
                                        //                               uris.append("  ");
                                        //                              break;
                                        //                             }
                                        //                           }
                                        //                         }
                                        //                       }
                                        uriField.setText((uriField.getText()
                                                + "  uri:" + uri.toString())
                                                .trim());
                                    }
                                }
                            }
                        });
            }

        };

        //                         {
        //                  
        //            protected boolean processResources()
        //                     {
        //                         
        //                         for (Iterator i = getURIs().iterator(); i.hasNext();)
        //                         {
        //                             try
        //                             {
        //                               uri = (URI)i.next();
        //                             }
        //                             catch (RuntimeException exception)
        //                             {
        //                               EMFEditUIPlugin.INSTANCE.log(exception);
        //                             }
        //                       
        //                       }
        //                       return true;
        //                     }
        //
        //                 };

        int i = loadResourceDialog.open();
        if (i == Window.OK)
            getText().setText(loadResourceDialog.getURIText());

    }

}