/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import java.util.ArrayList;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.executors.MCcallchain;

/**
 * 
 * <p>
 * ExecuteCallAction
 * </p>
 * Created : 23.04.2007
 * 
 * @author urs
 * @version $Revision: 1.1 $, $Id: ExecuteCallAction.java,v 1.1 2008/04/09
 *          22:43:08 urs Exp $
 */
public class ExecuteCallAction extends SelectionAction implements
		IObjectActionDelegate {
	public static final String ID = "ExecuteCallAction";

	public ExecuteCallAction() {
		this("Execute Transformation");
	}

	public ExecuteCallAction(String text) {
		super(text);

		// super(text,ExtendedImageRegistry.getInstance().getImageDescriptor(
		// CallchainEditPlugin.getPlugin().getImage("build")));

	}

	public ExecuteCallAction(IWorkbenchPage workbenchPage) {
		this("Execute Transformation");
		setWPart(workbenchPage.getActivePart());
		// workbenchPage.getActivePart().getSite().getSelectionProvider().
		// setWPart(workbenchPage);
	}

	@Override
	protected void initAction() {
		setId(ID);
		setActionDefinitionId("ExecuteCallAction");

	}

	//    
	// @Override
	// public String getText() {
	// return "ExecuteCallAction";
	// }

	public boolean isEnabled() {
		if (selection == null)
			return true;

		return selection != null && (selection instanceof Call);
	}

	@Override
	public void run() {

		MCcallchain ccallchain = new MCcallchain();
		ccallchain.executeTransformations((Call) selection, new ArrayList<String>());
		//ccallchain.startTransformation((Call) selection);

	}

	@Override
	public void setActivePart(IAction arg0, IWorkbenchPart arg1) {
		setWPart(arg1);

	}
	// @Override
	// public void run(IAction arg0) {
	// run();
	//		
	// }
	// @Override
	// public void selectionChanged(IAction arg0, ISelection arg1) {
	// setInterSelection(arg1);
	//		
	// }
}
