/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import org.eclipse.emf.edit.ui.provider.ExtendedImageRegistry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;
import de.urszeidler.eclipse.callchain.util.CallchainSwitch;

/**
 * <p>
 * ExecuteGenerator
 * </p>
 * Created : 14.05.2007
 * 
 * @author urs
 * @version $Revision: 1.1 $, $Id: ExecuteGenerator.java,v 1.2 2007/05/14
 *          15:45:29 urs Exp $
 */
public class ExecuteGenerator extends SelectionAction {

    public static final String ID = "ExecuteGenerator";

	public ExecuteGenerator(IWorkbenchPart page) {
        super(page);
    }

    public ExecuteGenerator(String text, ImageDescriptor image) {
        super(text, image);
    }

    public ExecuteGenerator(String text, int style) {
        super(text, style);
    }

    public ExecuteGenerator(String text) {
        super(text,ExtendedImageRegistry.getInstance().getImageDescriptor(CallchainEditPlugin.getPlugin().getImage("generate")));
        
        initAction();

    }

    /**
     * 
     */
    protected void initAction() {
        setId(ID);
        setActionDefinitionId("executeGenerator");
    }

    public ExecuteGenerator() {
        this("generate");
    }

    public ExecuteGenerator(IWorkbenchPage workbenchPage) {
		this();
		setWPart(workbenchPage.getActivePart());
	}

	public boolean isEnabled() {
		if(selection==null)
			return true;
		
        return (selection instanceof Generator);
    }

    @Override
    public void run() {
        Generator gen = (Generator) selection;
    	
      CallchainSwitch<Object> swt = new CallchainDoGenerationSwitch();
    swt.doSwitch(gen);

    	
    	
    	
//        WorkspaceModifyOperation op = new WorkspaceModifyOperation() {
//            public void execute(IProgressMonitor monitor) throws CoreException,
//                    InvocationTargetException, InterruptedException {
//            	
//                monitor.beginTask("Editor Generation process", 11);
//                try {
//                    try {
//                        Generator gen = (Generator) selection;
//                        
//                        final IProgressMonitor internMonitor = monitor;
//                        
//                        CallchainSwitch<Object> swt = new CallchainSwitch<Object>(){
//                        	@Override
//                        	public Object caseAM3_Generator(AM3_Generator object) {
//                        		// TODO Auto-generated method stub
//                        		return super.caseAM3_Generator(object);
//                        	}
//                        	@Override
//                        	public Object caseEMF_Generator(EMF_Generator object) {
//                        		
//                        		// TODO Auto-generated method stub
//                        		return super.caseEMF_Generator(object);
//                        	}
//                        	@Override
//                        	public Object caseGMF_Generator(GMF_Generator object) {
//                        		doGMF(object,internMonitor);
//                        		return super.caseGMF_Generator(object);
//                        	}
//							@Override
//                        	public Object caseGenerator(Generator object) {
//                        		//startGenerator(object);
//                        		return super.caseGenerator(object);
//                        	}
//                        	
//     
//                         };
//                        swt.doSwitch(gen);
//
//                        
//                       // gen.generate(monitor);
//
//                    } finally {
//                        //monitor.done();
//                    }
//                } catch (Exception ioe) {
//                    IStatus status = new Status(IStatus.ERROR, "", IStatus.OK,
//                            "Operation failed.", ioe);
//                    throw new CoreException(status);
//                }
//            }
//        };
//
//        IWorkbench workBench = PlatformUI.getWorkbench();

//        try {
//            Shell shell = workBench.getActiveWorkbenchWindow().getShell();
//            ProgressMonitorDialog dialog = new ProgressMonitorDialog(shell);
//            try {
//                dialog.run(true, false, op);
//             } finally {
//                dialog.close();
//            }// end of try catch
//        } catch (Exception e) {
//            CallchainEditPlugin.log("error while generating", IStatus.ERROR, e);
//         }

    }
    
//    void doGMF(GMF_Generator object, IProgressMonitor monitor) {
//		GMF_GeneratorExe generatorExe = new GMF_GeneratorExe(object,PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell());
//		generatorExe.generate(monitor);
//		
//	}

}
