package de.urszeidler.eclipse.callchain.ui.popup.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.importer.ImportFromLauchConfig;

public class CreateFromLauchConfigAction implements IObjectActionDelegate {

	private IFile selectedFile;

    /**
	 * Constructor for Action1.
	 */
	public CreateFromLauchConfigAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		//Shell shell = new Shell();
        if(selectedFile==null)
            return ;
        ImportFromLauchConfig importFromLauchConfig = new ImportFromLauchConfig();
        
        Calls calls = importFromLauchConfig.createCallchainByLauchConfig(selectedFile);
 //       IContainer parent = selectedFile.getParent();
         String fullPath = selectedFile.getFullPath().toOSString();
         fullPath = fullPath.substring(0, fullPath.indexOf(selectedFile.getFileExtension()));
         fullPath += "callchain";
        URI uri = URI.createPlatformResourceURI(fullPath,true);
        importFromLauchConfig.saveCalls(uri, calls);
         
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
        if (selection instanceof IStructuredSelection){
            IStructuredSelection ss = (IStructuredSelection) selection;
            Object firstElement = ss.getFirstElement();
            if (firstElement instanceof IFile) {
                IFile file = (IFile) firstElement;
                selectedFile = file;
            }//end of if (firstElement instanceof IFile)
            
        }//end of if (selection instanceof IStructuredSelection)
	}

}
