<?xml version="1.0"?>
<xsl:stylesheet
   version="1.1"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html" indent="no" encoding="UTF-8" />

<xsl:template match="toc" >
   <html>
   <head>

  <link rel="stylesheet" type="text/css" href="style.css"></link>
   
   </head>
   
      <body>
      <h1>Table of Contents</h1>

<p class="text" >
This plug in provides a diagram editor for modeling a process of model transformations in ATL.
It describes the structure of a transformation flow. 

The plug in has also the ability to execute the transformations.

You can see it as an planing and execution board.

      </p>
         <h1><xsl:value-of select="@label" /></h1>
         <ul>
            <xsl:apply-templates />
         </ul>
         
      </body>
   </html>
</xsl:template>

<xsl:template match="topic">
   <li>
      <xsl:choose>
         <xsl:when test="@href">
            <!-- Only add a hyperlink when there is something to link to -->
            <xsl:element name="a">
               <xsl:attribute name="href">
                          	<xsl:variable name="ref" select="@href"/>
               
                  
                   <xsl:value-of select="substring-after($ref, 'html/')"/>
                  </xsl:attribute>
               <xsl:value-of select="@label" />
            </xsl:element>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="@label" />
         </xsl:otherwise>
      </xsl:choose>

      <!-- If there are any nested topics, then start a new sub-list -->
      <xsl:if test="descendant::topic">
         <ul>
            <xsl:apply-templates/>
         </ul>
      </xsl:if>
   </li>
</xsl:template>

</xsl:stylesheet>